//
// Copyright (C) 2007-2016  Hideaki Takenaka, Hiroko Yamada
// Julian day converter 2007/02/18
//
// addded TransDateToJD function  2016/07/01

import java.math.BigDecimal;
import java.math.RoundingMode;
import java.lang.Math.*;
import java.io.*;

public class jday{


jday(){

}


public int ymd2jd(int YYYY, int MM, int DD)
{

int JD,A,B;


  if(MM==1 || MM==2)
  {
    YYYY = YYYY-1;
    MM   = MM+12;
  }

  A = (int)(YYYY/100);
  B = 2-A + (int)(A/4);


  JD = (int)(Math.round((int)(365.25*(YYYY+4716)) + (int)(30.6001*(MM+1))+ DD + B -1524.5));

 return(JD);
}


public double TransDateToJD(int year, int month, int day, int hour, int minute, int sec)
{
  double jd;
  double A,B;

  if(month<3)
  {
    year -=1;
    month+=12;
  }
  A = (int)(year/100);
  B = 2-A + (int)(A/4);

  jd = Math.round((int)(365.25*(year+4716)*1.0) ) + (int)(30.6001*(month+1)*1.0)+ day + B +(hour/24.0)+(minute/1440.0)+(sec/86400.0) -1524.5;
	
  return jd;
  
}


public int tddy(int YYYY, int MM, int DD)
{

 int JD;

 JD = ymd2jd(YYYY,MM,DD) - ymd2jd(YYYY,1,0);

 return(JD);
}



public int ymd2mjd(int YYYY, int MM, int DD)
{

int MJD,A,B;


  if(MM==1 || MM==2)
  {
    YYYY = YYYY-1;
    MM   = MM+12;
  }

  A = (int)(YYYY/100);
  B = 2-A + (int)(A/4);


  MJD = (int)(Math.round((int)(365.25*(YYYY+4716)) + (int)(30.6001*(MM+1))+ DD + B -1524.5)-2400000.5);

 return(MJD);
}


public int[] jd2ymdhn(double JD)
{
    int aa,bb,cc,ee,ff,gg,hh;
    double ii,jd;
    int year,mon,day,hour,min,sec;
    int YYYY,MM,DD,HH,MN,SC;
    double TM;
    
    int ans[] = new int[7+1];
    
        
       jd=JD;

        aa=(int)(jd+68569.5);
        bb=(int)(aa/36524.25);
        cc=aa-(int)(36524.25*bb+0.75);
        ee=(int)((cc+1)/365.25025);
        ff=cc-(int)(365.25*ee)+31;
        gg=(int)(ff/30.59);
        hh=(int)(gg/11);
        ii=jd+0.5-(int)(jd+0.5);
        
       YYYY=100*(bb-49)+ee+hh;
       MM=gg-12*hh+2;
       DD=ff-(int)(30.59*gg);
       HH=(int)(24*ii);
       MN=(int)(1440*(ii-HH/24.0));
       SC=(int)(86400*(ii-HH/24.0-MN/1440.0));
      
       ans[1] = YYYY;
       ans[2] = MM;
       ans[3] = DD;
       ans[4] = HH;
       ans[5] = MN;
       ans[6] = SC;
                     
 return(ans);
}// jd2ymdhn


public int[] mjd2ymdhn(double MJD)
{
    int aa,bb,cc,ee,ff,gg,hh;
    double ii,jd,mjd;
    int year,mon,day,hour,min,sec;
    int YYYY,MM,DD,HH,MN,SC;
    double TM;
    
    int ans[] = new int[7+1];
    
        
       jd=MJD+2400000.5;

        aa=(int)(jd+68569.5);
        bb=(int)(aa/36524.25);
        cc=aa-(int)(36524.25*bb+0.75);
        ee=(int)((cc+1)/365.25025);
        ff=cc-(int)(365.25*ee)+31;
        gg=(int)(ff/30.59);
        hh=(int)(gg/11);
        ii=jd+0.5-(int)(jd+0.5);
        
       YYYY=100*(bb-49)+ee+hh;
       MM=gg-12*hh+2;
       DD=ff-(int)(30.59*gg);
       HH=(int)(24*ii);
       MN=(int)(1440*(double)(ii-HH/24.0));
       SC=(int)(86400*(ii-HH/24.0-MN/1440.0));
      
       ans[1] = YYYY;
       ans[2] = MM;
       ans[3] = DD;
       ans[4] = HH;
       ans[5] = MN;
       ans[6] = SC;
                     
       //TM = HH+((MN+(SC/60.0))/60.0);

 return(ans);
}// mjd2ymdhn  

}// class